
mtdt = LibStub("AceAddon-3.0"):NewAddon("MeantToDoThat", "AceConsole-3.0", "AceEvent-3.0")

local options = {
	name = "Meant To Do That",
	handler = mtdt,
	type = 'group',
	args = {
		opt = {
			name = 'Options',
			desc = 'Opens options dialog',
			type = 'execute',
			func = function () end,
			guiHidden = true,
			order = 0,
		},
		perChar = {
			type = 'toggle',
			name = 'Settings for character',
			desc = 'Save setting for character, not account',
			set = 'Set',
			get = 'Get',
			order = 10,
			hidden = true,
		},
		msg = {
			type = 'input',
			name = 'Death message',
			desc = 'Message to be sent upon death',
			set = 'Set',
			get = 'Get',
			width = "double",
			order = 11,
		},
		output = {
			hidden = true,
			type = 'select',
			name = 'Output channel',
			desc = 'Channel to post message.\nSmart group will choose Instance, Raid, or Party depending on what type of group you are in.',
			get = 'Get',
			set = 'Set',
			values = {
				smart = 'Smart group',
				whisper = 'Whisper',
				instance = 'Instance',
				party = 'Party',
				raid = 'Raid',
			},
		},
		whisperGroup = {
			name = '',
			type = 'group',
			cmdHidden = true,
			inline = true,
			set = "Set",
			get = "Get",
			args = {
				whisper = {
					type = 'toggle',
					name = 'Whisper player',
					desc = 'Whisper a player instead of chat',
					order = 20,
				},
				reciever = {
					type = 'input',
					name = 'Message reciever',
					desc = 'Player to recieve your message',
					order  = 21,
				},
			},
		},
	},
}

local defaults = {
	char = {
		msg = "I meant to do that!",
		perChar = false,
		whisper = false,
		reciever = nil,
		output = 'smart',
	},
}

function mtdt:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("MeantToDoThatDB", defaults)
	-- options.args.profiles = LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db, true)
	LibStub("AceConfig-3.0"):RegisterOptionsTable("Meant To Do That", options)
	self.profilesFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Meant To Do That")
	mtdt:RegisterChatCommand("meanttodothat", "SlashProcessorFunc")
	mtdt:RegisterChatCommand("mtdt", "SlashProcessorFunc")
	mtdt:RegisterEvent("PLAYER_DEAD")
end

function mtdt:OnEnable()
	mtdt:FetchPresence()
end

function mtdt:OnDisable()
	--
end

function mtdt:SlashProcessorFunc( input )
	if input:trim() == "opt" then
		LibStub("AceConfigDialog-3.0"):Open("Meant To Do That")
	elseif input:trim() == "test" then
		mtdt:PLAYER_DEAD()
	else
		LibStub("AceConfigCmd-3.0").HandleCommand(mtdt, "mtdt", "Meant To Do That", input)
	end
end

function mtdt:Get( info )
	return self.db.char[info[#info]]
end

function mtdt:Set( info, value )
	self.db.char[info[#info]] = value
	if info[#info] == "reciever" then
		mtdt:FetchPresence()
	end
end

function mtdt:PLAYER_DEAD()
	if (self.db.char.whisper and self.db.char.reciever) then
		if (self.reciever) then
			BNSendWhisper(self.reciever, self.db.char.msg)
		else
			SendChatMessage(self.db.char.msg, WHISPER, nil, self.db.char.reciever)
		end
	elseif (IsInGroup(LE_PARTY_CATEGORY_INSTANCE)) then
		SendChatMessage(self.db.char.msg, INSTANCE_CHAT)
	elseif (IsInRaid()) then
		SendChatMessage(self.db.char.msg, RAID)
	elseif (IsInGroup(LE_PARTY_CATEGORY_HOME)) then
		SendChatMessage(self.db.char.msg, PARTY)
	else		
		mtdt:Print("<No target found>")
	end
end

function mtdt:FetchPresence()
	if (self.db.char.reciever) then
		self.reciever = GetAutoCompletePresenceID(self.db.char.reciever)
	end
end